unit sets;
{ Авторское право (С) <2003-2004> <Волченко В. И.>

  Эта библиотека - бесплатное ПО; Вы можете распространять её и/или изменять
  по условиям GNU Library General Public License как опубликовано Free
  Software Foundation; или версии 2 Лицензии, или (на Ваш выбор) любой поздней
  версии.

  Эта программа распространяется с надеждой быть полезной, но БЕЗО ВСЯКОЙ
  ГАРАНТИИ; даже без подразумеваемой ТОРГОВОЙ гарантии или СООТВЕТСТВИЯ
  ОПРЕДЕЛЁННОЙ ЦЕЛИ. См. GNU Library General Public License для дальнейшей
  информации.

  Вы должны были получить копию GNU Library General Public License с этой
  библиотекой; если нет, пишите в Free Software Foundation, Inc., 59 Temple
  Place - Suite 330, Boston, MA 02111-1307, США.
}
//Файл взят из программы VVFStat.
{$ifndef fpc}
{$ifndef VIRTUALPASCAL}
{$ifndef delphi}
{$define pabc}
{$endif}
{$endif}
{$endif}
{$ifdef fpc}
{$mode objfpc}
{$endif}
{$H+}

interface

uses
  Classes, SysUtils, contnrs;


procedure Exchange(var a:integer;var b:integer);overload;
procedure Exchange(var a:extended;var b:extended);overload;
procedure Exchange(var a:string;var b:string);overload;
function ESCopy(const s:string;i,j:integer):string;
function ESPosReplace(const s,s1:string;i,j:integer):string;
function ESReplaceAll(const s1,s2,s3:string):string;
function GetNumber(const S:string):extended;
function RemoveNumber(const s:string):string;
function MyFloatToStr(const F:double;i,j:integer):string;
function DoubleDirSep(const s:string):string;

type TChSet=set of char;

{ TObjectCache }

TObjectCache=class(TObjectList)
public
  procedure Clear;
end;

function MyVal({$ifndef pabc}const {$endif}St:String;ADefault:Extended{$ifdef pabc}:={$else}={$endif}0):Extended;



const DigitSet:TChSet=['0'..'9','.'];
var NewAlg:boolean{$ifdef pabc}:={$else}={$endif}false;
    UseMaxima:boolean{$ifdef pabc}:={$else}={$endif}false;
    NotCount:boolean{$ifdef pabc}:={$else}={$endif}false;
    ValError:boolean{$ifdef pabc}:={$else}={$endif}false;
    MaximaPath:string;

implementation
function MyVal(const St:String;ADefault:Extended{$ifdef pabc}{$else}=0{$endif}):Extended;
var
  i,c: Integer;
  s: String;
begin
  s:=St;
  i:=pos(',',s);
  if i>0 then s[i]:='.';
  Val(s,Result,c);
  if c>0 then
  begin
    Result:=ADefault;
    ValError:=true;
  end else ValError:=false;
end;

function ESCopy(const s:string;i,j:integer):string;
var k:integer;
begin
 k:=length(s);
 if i>j then Exchange(i,j);
 if i<1 then i:=1;
 if j>k then j:=k;
 Result:=copy(s,i,j-i+1);
end;

function FirstNumber(const S:string;var Value:extended;var LastStr:string):Boolean;
var
    s1: String;
    code:integer;
begin
 Result:=false;
 Val(s,value,code);
 if code=1 then exit;
 if code=0 then begin Result:=true;LastStr:='';exit;end;
 s1:=ESCopy(s,1,code-1);
 Val(s1,value,code);
 if code<>0 then exit;
 LastStr:=ESCopy(s,code,Length(s));
 Result:=true;
end;

function GetNumber(const S:string):extended;
var s1:string;
begin
 FirstNumber(s,Result,s1);
end;

function RemoveNumber(const s:string):string;
var v:extended;
begin
 if not FirstNumber(s,v,Result) then Result:=s;
end;

function ESPosReplace(const s,s1:string;i,j:integer):string;
begin
 if i>j then Exchange(i,j);
 if i<1 then i:=1;
 if j>length(s) then j:=Length(s);
 if i>1 then Result:=ESCopy(s,1,i) else Result:='';
 Result:=Result+s1;
 if j<Length(s) then Result:=Result+ESCopy(s,j+1,Length(s));
end;

procedure Exchange(var a:integer;var b:integer);
var c:integer;
begin
 c:=a;a:=b;b:=c;
end;

procedure Exchange(var a:extended;var b:extended);
var c:extended;
begin
 c:=a;a:=b;b:=c;
end;

procedure Exchange(var a:string;var b:string);
var c:string;
begin
 c:=a;a:=b;b:=c;
end;

function ESReplaceAll(const s1,s2,s3:string):string;
var
  i: Integer;
begin
 Result:='';i:=1;
 repeat
  if (Copy(s1,i,length(s2))=s2){and
   not ((i>1)or not (s1[i-1] in ['a'..'z','A'..'Z']))}
   then begin
   i:=i+length(s2)-1;
   Result:=Result+s3;
  end else Result:=Result+s1[i];
  inc(i);
 until i>length(s1);
end;

{ TObjectCache }

procedure TObjectCache.Clear;
var
  i: Integer;
  F: {$ifdef pabc}system.object{$else}TObject{$endif};
begin
  for i:=Count-1 downto 0 do
  begin
    F:=Self[i];
    {$ifdef pabc}RemoveAt{$else}Delete{$endif}(i);
    {$ifndef pabc}
    if assigned(F) then F.Free;
    {$else}
    F:=nil;
    {$endif}
  end;
end;

function MyFloatToStr(const F:double;i,j:integer):string;
begin
  Result:=FloatToStr(F);
end;

function DoubleDirSep(const s:string):string;
var i:Integer;
    Finished:boolean;
    s1:string;
begin
 s1:=s;
 {$ifdef MSWINDOWS}
  repeat
    Finished:=true;
    for i:=1 to length(s) do
      if (s1[i]='\') and (i<length(s1))and(s1[i+1]<>'\')and((i=1)or(s1[i-1]<>'\')) then begin
       s1:=LeftStr(s1,i)+RightStr(s1,length(s1)-i+1);
       Finished:=false;
       break;
      end;
  until finished;
  {$ENDIF}
  Result:=s1;
end;

end.

